"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Znel_znoteElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Znel = void 0;
const meta_1 = require("./src/meta");
const node_html_parser_1 = require("node-html-parser");
const reminder_1 = require("./src/reminder");
const content_1 = require("./src/content");
class Znel {
    constructor(znel) {
        _Znel_znoteElement.set(this, void 0);
        const document = (0, node_html_parser_1.parse)(znel);
        const element = document.querySelector("znote");
        if (!element)
            throw new Error("Invalid znel file. Must contain ZNote element.");
        __classPrivateFieldSet(this, _Znel_znoteElement, element, "f");
        this.validate();
    }
    get version() {
        const version = __classPrivateFieldGet(this, _Znel_znoteElement, "f").getAttribute("znelVersion");
        if (!version)
            throw new Error("Invalid znel. znelVersion attribute is required.");
        return version;
    }
    get metadata() {
        const metadataElement = __classPrivateFieldGet(this, _Znel_znoteElement, "f").querySelector("zmeta");
        if (!metadataElement)
            throw new Error("Invalid znel. No ZMeta element found");
        return new meta_1.ZMeta(metadataElement);
    }
    get tags() {
        const tags = [];
        const tagElements = __classPrivateFieldGet(this, _Znel_znoteElement, "f").querySelectorAll("ztag");
        for (let element of tagElements) {
            tags.push(element.textContent);
        }
        return tags;
    }
    get reminders() {
        const reminders = [];
        const reminderElements = __classPrivateFieldGet(this, _Znel_znoteElement, "f").querySelectorAll("zreminder");
        for (let element of reminderElements) {
            reminders.push(new reminder_1.ZReminder(element));
        }
        return reminders;
    }
    get content() {
        const zcontentElement = __classPrivateFieldGet(this, _Znel_znoteElement, "f").querySelector("zcontent");
        if (!zcontentElement)
            throw new Error("Invalid znel. No ZContent element found");
        return new content_1.ZContent(zcontentElement, this.metadata.noteType);
    }
    validate() {
        this.version && this.content;
    }
}
exports.Znel = Znel;
_Znel_znoteElement = new WeakMap();
