"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _ZReminder_reminderElement;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ZReminder = void 0;
const utils_1 = require("./utils");
class ZReminder {
    constructor(reminderElement) {
        _ZReminder_reminderElement.set(this, void 0);
        __classPrivateFieldSet(this, _ZReminder_reminderElement, reminderElement, "f");
    }
    get createdTime() {
        const time = __classPrivateFieldGet(this, _ZReminder_reminderElement, "f").getAttribute("created-time");
        if (!time)
            throw new Error("Reminder does not have created-time attribute.");
        return new Date(time);
    }
    get modifiedTime() {
        const time = __classPrivateFieldGet(this, _ZReminder_reminderElement, "f").getAttribute("modified-time");
        if (!time)
            throw new Error("Reminder does not have modified-time attribute.");
        return new Date(time);
    }
    get isCompleted() {
        const isCompleted = __classPrivateFieldGet(this, _ZReminder_reminderElement, "f").getAttribute("is-completed");
        if (!isCompleted)
            throw new Error("Reminder does not have is-completed attribute.");
        return Number(isCompleted) !== 0;
    }
    get isRead() {
        const isRead = __classPrivateFieldGet(this, _ZReminder_reminderElement, "f").getAttribute("is-read");
        if (!isRead)
            throw new Error("Reminder does not have is-read attribute.");
        return Number(isRead) !== 0;
    }
    get type() {
        const type = __classPrivateFieldGet(this, _ZReminder_reminderElement, "f").getAttribute("type");
        if (!type)
            throw new Error("Reminder does not have type attribute.");
        return type;
    }
    get reminderTime() {
        return (0, utils_1.getAsDateRequired)(__classPrivateFieldGet(this, _ZReminder_reminderElement, "f"), "ZReminderTime");
    }
    validate() {
        this.createdTime && this.modifiedTime && this.type && this.isRead && this.isCompleted && this.reminderTime;
    }
}
exports.ZReminder = ZReminder;
_ZReminder_reminderElement = new WeakMap();
